package com.tiptimes.service;

import com.tiptimes.model.Answer;
import com.tiptimes.model.PerformanceSummary;
import com.tiptimes.model.Record;
import com.tiptimes.model.Review;
import com.tiptimes.model.exportDTO.FullTimeWorkPerson;
import com.tiptimes.model.exportDTO.SiteCondition;
import org.apache.ibatis.annotations.Param;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

public interface QuestionnaireService {
  /**
   * 根据上报人和问卷id查询上报记录id
   * @param questionnaireUuid 问卷id
   * @param createId 上报人唯一标识
   * @return
   */
  Long selectRecordId(Long questionnaireUuid,String createId);

  /**
   * 添加上报记录数据
   * @param record 上报记录
   * @return
   */
  Long insertRecord(Record record);

  /**
   * 根据上报记录id删除原上报数据
   * @param recordId 上报记录id
   * @return
   */
  Integer delAnswer(Long recordId);

  /**
   * 新增新的上报数据
   * @param answerList
   * @param recordId
   * @return
   */
  Integer insertAnswer(List<Answer> answerList,Long recordId);

  /**
   * 修改数据上报状态
   * @param record
   * @return
   */
  Integer updateRecord(Record record);

  /**
   * 通过记录id删除原有备注
   * @param recordId
   * @return
   */
  Integer delView(Long recordId,Long questionsId);

  /**
   * 添加新的备注
   * @param review
   * @return
   */
  Integer insertReview(List<Review> review,Long recordId);


  /**
   *根据记录id查询上报数据详情
   * @param recordId 记录id
   * @return
   */
  List<Answer> selectAnswerByRecordId(Long recordId);

  /**
   *根据记录id查询评审备注详情
   * @param recordId 记录id
   * @return
   */
  List<Review> selectReviewByRecordId(Long recordId);

  /**
   *根据记录id查询评审备注详情
   * @param recordId 记录id
   * @return
   */
  Record selectById(Long recordId);

  /**
   * 按条件查询上报记录
   * @param record 筛选条件
   * @return
   */
  List<Record> selectRecordList(Record record);

  //根据选项id查询文件对应id
  List<String> selectFileId(Long optionId,Long recordId);

  //统计众创空间的分数
  List<PerformanceSummary> selectPerformanceSummaryList(PerformanceSummary performanceSummary);

  void exportFullTimeWorkPerson(HttpServletRequest request, HttpServletResponse response, String index, String recordId);

  void exportPerformanceSummary(HttpServletRequest request, HttpServletResponse response);

  Integer updateAnswerScore(Answer answer);
}


